//-----------------------------------------
// LScript Modeler template
//
// Copyright 2024 Michael Green
// mike@mikegreen.name
//

myversion=1.0;

//1.0
// Works I think.
// does blurring properly now.... Maybe :) 
//0.5
// does blurring properly now.... Maybe :) 

//0.1 
// first implementation, cheap hack.

@version 2.2
@warnings
@script modeler

// global values go here
gmaps;

main
{
//debug();
	gmaps=GetVMapList(@VMSUBPATCH,VMWEIGHT,VMTEXTURE,VMMORPH,VMSPOT,VMRGB,VMRGBA@);
	for(i=1;i<=2;i++)
	{
		myset[i]=recall("MGBlurVmaps_"+i.asStr(),1);
	}
    // requester code goes here

    reqbegin("MG Weight Map Smooth v"+myversion);

    c[1] = ctlnumber("Strength",myset[1]);
    c[2] = ctlinteger("Iterations",myset[2]);
	c[3] = ctllistbox("Maps", 150,300,"l_count","l_name");
    return if !reqpost();

    // get requester control values here
    for(i=1;i<=c.size();i++)
    {
		myval=getvalue(c[i]);
		if(i<3)
		{
			if(myval<=0) myval=1;
			store("MGBlurVmaps_"+i.asStr(),myval);
		}
		myset[i]=myval;

	}

    reqend();

	BlurVMaps(myset);
}

l_count
{
	return(gmaps.size());
}

l_name:value
{
	return(gmaps[value].name);
}

BlurVMaps:pset
{
	selmode(USER);
	editbegin();
		mypoints=points;
		moninit(pset[3].size()*points.size());
		for(i=1;i<=pset[3].size();i++)
		{
			mycurrentmap=gmaps[pset[3][i]];
			for(j=1;j<=pset[2];j++)
			{
				BlurPoints(mycurrentmap,pset[1]);
			}
		}
		monend();
	editend();
}


BlurPoints:pcurr,pamount
{
	index=0;
	foreach(p,points)
	{
		index++;
		mynewvals[index][1]=p;
		mynewvals[index][2]=BlurPoint(p,pcurr,pamount);
		monstep(1);
	}
	for(i=1;i<=index;i++)
	{
		pcurr.setValue(mynewvals[i][1],mynewvals[i][2]);
	}
}

BlurPoint:ppoint,pcurr,pamount
{
	neighbours=GetNeighbours(ppoint);
    myval=AverageMapPoint(neighbours,pcurr);
    if(pcurr.isMapped(ppoint))
    {
     	oldval=pcurr.getValue(ppoint);
     	for(i=1;i<=pcurr.dimensions;i++)
		{
			newval[i]=(myval[i]-oldval[i])*pamount+oldval[i];
		}
	}
	else
	{
     	for(i=1;i<=pcurr.dimensions;i++)
		{
				newval[i]=myval[i]*pamount;
		}
	}
	return(newval);
}

AverageMapPoint:ppoints,pmap
{
	for(i=1;i<=pmap.dimensions;i++)
	{
    	mytotal[i]=0;
 	}
    foreach(p,ppoints)
    {
		if(pmap.isMapped(p))
		{
     		val=pmap.getValue(p);
			for(i=1;i<=pmap.dimensions;i++)
			{
				mytotal[i]=mytotal[i]+val[i];
			}
		}
	}
	for(i=1;i<=pmap.dimensions;i++)
	{
		average[i]=mytotal[i]/ppoints.size();
	}
	return(average);
}


GetNeighbours:ppoint
{
	mypolys=ppoint.polygon();
	if(!mypolys)
		return(nil);
	mypoints=nil;
	foreach(p,mypolys)
	{
		for(i=1;i<=p.pointCount;i++)
		{
			mypoints+=p.points[i];
		}
	}
	mypoints.sortA();
	mypoints.reduce();
	mypoints.trunc();
	return(mypoints);
}

GetVMapList:ptypes    // will return a list of VMaps of certain types, or all if this is nil
{
//debug();
	if(ptypes==nil)
		ptypes=@VMSUBPATCH,VMWEIGHT,VMTEXTURE,VMMORPH,VMSPOT,VMRGB,VMRGBA@;
	mymap=VMap();
	vmaplist=nil;
	index=1;
	while(mymap)
	{
		if(ptypes.contains(mymap.type) && !mymap.name.contains("MGBlurVmaps"))
		{
			vmaplist[index]=mymap;
			index++;
		}
		mymap=mymap.next();
	}
	return(vmaplist);
}